/*
 * Project 	: MeRuSharp
 * version 	: 1.0(initial version)
 * Date		: 2004/06/12
 *
 * Written by InspiredWorkS
 */

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Microsoft.DirectX.AudioVideoPlayback;

namespace MeRuSharp
{
	/// <summary>
	/// MeRu#̃CtH[
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.MenuItem fileMenuCategory;
		private System.Windows.Forms.Panel videoPanel;
		private System.Windows.Forms.ToolBarButton stopButton;
		private System.Windows.Forms.ToolBarButton playButton;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.MenuItem openFileMenu;
		private System.Windows.Forms.ToolBarButton pauseButton;
		private System.Windows.Forms.ToolBar controlToolBar;
		private System.Windows.Forms.ImageList controlToolBarImageList;
		private System.Windows.Forms.OpenFileDialog openFileDialog;

		public MainForm()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent ĂяǒɁARXgN^ R[hǉĂB
			//
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent() {
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.controlToolBarImageList = new System.Windows.Forms.ImageList(this.components);
			this.controlToolBar = new System.Windows.Forms.ToolBar();
			this.pauseButton = new System.Windows.Forms.ToolBarButton();
			this.openFileMenu = new System.Windows.Forms.MenuItem();
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.playButton = new System.Windows.Forms.ToolBarButton();
			this.stopButton = new System.Windows.Forms.ToolBarButton();
			this.videoPanel = new System.Windows.Forms.Panel();
			this.fileMenuCategory = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// openFileDialog
			// 
			this.openFileDialog.Filter = resources.GetString("openFileDialog.Filter");
			this.openFileDialog.Title = resources.GetString("openFileDialog.Title");
			// 
			// controlToolBarImageList
			// 
			this.controlToolBarImageList.ImageSize = ((System.Drawing.Size)(resources.GetObject("controlToolBarImageList.ImageSize")));
			this.controlToolBarImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("controlToolBarImageList.ImageStream")));
			this.controlToolBarImageList.TransparentColor = System.Drawing.Color.Magenta;
			// 
			// controlToolBar
			// 
			this.controlToolBar.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("controlToolBar.Anchor")));
			this.controlToolBar.Appearance = ((System.Windows.Forms.ToolBarAppearance)(resources.GetObject("controlToolBar.Appearance")));
			this.controlToolBar.AutoSize = ((bool)(resources.GetObject("controlToolBar.AutoSize")));
			this.controlToolBar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
						this.playButton,
						this.pauseButton,
						this.stopButton});
			this.controlToolBar.ButtonSize = ((System.Drawing.Size)(resources.GetObject("controlToolBar.ButtonSize")));
			this.controlToolBar.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("controlToolBar.Dock")));
			this.controlToolBar.DropDownArrows = ((bool)(resources.GetObject("controlToolBar.DropDownArrows")));
			this.controlToolBar.Enabled = ((bool)(resources.GetObject("controlToolBar.Enabled")));
			this.controlToolBar.ImageList = this.controlToolBarImageList;
			this.controlToolBar.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("controlToolBar.ImeMode")));
			this.controlToolBar.Location = ((System.Drawing.Point)(resources.GetObject("controlToolBar.Location")));
			this.controlToolBar.Name = "controlToolBar";
			this.controlToolBar.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("controlToolBar.RightToLeft")));
			this.controlToolBar.ShowToolTips = ((bool)(resources.GetObject("controlToolBar.ShowToolTips")));
			this.controlToolBar.Size = ((System.Drawing.Size)(resources.GetObject("controlToolBar.Size")));
			this.controlToolBar.TabIndex = ((int)(resources.GetObject("controlToolBar.TabIndex")));
			this.controlToolBar.TextAlign = ((System.Windows.Forms.ToolBarTextAlign)(resources.GetObject("controlToolBar.TextAlign")));
			this.controlToolBar.Visible = ((bool)(resources.GetObject("controlToolBar.Visible")));
			this.controlToolBar.Wrappable = ((bool)(resources.GetObject("controlToolBar.Wrappable")));
			this.controlToolBar.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.controlToolBar_ButtonClick);
			// 
			// pauseButton
			// 
			this.pauseButton.Enabled = ((bool)(resources.GetObject("pauseButton.Enabled")));
			this.pauseButton.ImageIndex = ((int)(resources.GetObject("pauseButton.ImageIndex")));
			this.pauseButton.Text = resources.GetString("pauseButton.Text");
			this.pauseButton.ToolTipText = resources.GetString("pauseButton.ToolTipText");
			this.pauseButton.Visible = ((bool)(resources.GetObject("pauseButton.Visible")));
			// 
			// openFileMenu
			// 
			this.openFileMenu.Enabled = ((bool)(resources.GetObject("openFileMenu.Enabled")));
			this.openFileMenu.Index = 0;
			this.openFileMenu.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("openFileMenu.Shortcut")));
			this.openFileMenu.ShowShortcut = ((bool)(resources.GetObject("openFileMenu.ShowShortcut")));
			this.openFileMenu.Text = resources.GetString("openFileMenu.Text");
			this.openFileMenu.Visible = ((bool)(resources.GetObject("openFileMenu.Visible")));
			this.openFileMenu.Click += new System.EventHandler(this.openFileMenu_Click);
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.fileMenuCategory});
			this.mainMenu.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("mainMenu.RightToLeft")));
			// 
			// playButton
			// 
			this.playButton.Enabled = ((bool)(resources.GetObject("playButton.Enabled")));
			this.playButton.ImageIndex = ((int)(resources.GetObject("playButton.ImageIndex")));
			this.playButton.Text = resources.GetString("playButton.Text");
			this.playButton.ToolTipText = resources.GetString("playButton.ToolTipText");
			this.playButton.Visible = ((bool)(resources.GetObject("playButton.Visible")));
			// 
			// stopButton
			// 
			this.stopButton.Enabled = ((bool)(resources.GetObject("stopButton.Enabled")));
			this.stopButton.ImageIndex = ((int)(resources.GetObject("stopButton.ImageIndex")));
			this.stopButton.Text = resources.GetString("stopButton.Text");
			this.stopButton.ToolTipText = resources.GetString("stopButton.ToolTipText");
			this.stopButton.Visible = ((bool)(resources.GetObject("stopButton.Visible")));
			// 
			// videoPanel
			// 
			this.videoPanel.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("videoPanel.Anchor")));
			this.videoPanel.AutoScroll = ((bool)(resources.GetObject("videoPanel.AutoScroll")));
			this.videoPanel.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("videoPanel.AutoScrollMargin")));
			this.videoPanel.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("videoPanel.AutoScrollMinSize")));
			this.videoPanel.BackColor = System.Drawing.Color.Black;
			this.videoPanel.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("videoPanel.Dock")));
			this.videoPanel.Enabled = ((bool)(resources.GetObject("videoPanel.Enabled")));
			this.videoPanel.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("videoPanel.ImeMode")));
			this.videoPanel.Location = ((System.Drawing.Point)(resources.GetObject("videoPanel.Location")));
			this.videoPanel.Name = "videoPanel";
			this.videoPanel.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("videoPanel.RightToLeft")));
			this.videoPanel.Size = ((System.Drawing.Size)(resources.GetObject("videoPanel.Size")));
			this.videoPanel.TabIndex = ((int)(resources.GetObject("videoPanel.TabIndex")));
			this.videoPanel.Text = resources.GetString("videoPanel.Text");
			this.videoPanel.Visible = ((bool)(resources.GetObject("videoPanel.Visible")));
			// 
			// fileMenuCategory
			// 
			this.fileMenuCategory.Enabled = ((bool)(resources.GetObject("fileMenuCategory.Enabled")));
			this.fileMenuCategory.Index = 0;
			this.fileMenuCategory.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
						this.openFileMenu});
			this.fileMenuCategory.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("fileMenuCategory.Shortcut")));
			this.fileMenuCategory.ShowShortcut = ((bool)(resources.GetObject("fileMenuCategory.ShowShortcut")));
			this.fileMenuCategory.Text = resources.GetString("fileMenuCategory.Text");
			this.fileMenuCategory.Visible = ((bool)(resources.GetObject("fileMenuCategory.Visible")));
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScaleBaseSize")));
			this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
			this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
			this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
			this.ClientSize = ((System.Drawing.Size)(resources.GetObject("$this.ClientSize")));
			this.Controls.Add(this.videoPanel);
			this.Controls.Add(this.controlToolBar);
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.MaximumSize = ((System.Drawing.Size)(resources.GetObject("$this.MaximumSize")));
			this.Menu = this.mainMenu;
			this.MinimumSize = ((System.Drawing.Size)(resources.GetObject("$this.MinimumSize")));
			this.Name = "MainForm";
			this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
			this.StartPosition = ((System.Windows.Forms.FormStartPosition)(resources.GetObject("$this.StartPosition")));
			this.Text = resources.GetString("$this.Text");
			this.ResumeLayout(false);
		}
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |Cg
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		//---------------------------------------------------------------------
		// ȉ蓮ŒǉR[h
		//---------------------------------------------------------------------

		/// <summary>
		/// v[[IuWFNgiManaged DirectXŒ`Ăj
		/// </summary>
		public Video videoPlayer = null;

		/// <summary>
		/// t@CJ
		/// </summary>
		private void openMediaFile(string fileName)
		{
			try {
				// ݊JĂt@CΕ
				if (videoPlayer != null) {
					videoPlayer.Dispose();
				}
				
				// ĐpIuWFNg̍쐬
				videoPlayer = new Video(fileName, false);
				// `̐ݒ
				videoPlayer.Owner = videoPanel;
				// ĐJn
				videoPlayer.Play();
			} catch (Microsoft.DirectX.DirectXException) {
				// w肳ꂽt@CĐłȂA܂͍ĐɑΉĂȂꍇ̏
				MessageBox.Show(fileName + "\n\ñt@C`ɂ͑ΉĂ܂", "File Format Error",
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}
		}

		/// <summary>
		/// Cj[ [t@C][J]IɌĂ΂
		/// </summary>
		private void openFileMenu_Click(object sender, System.EventArgs e)
		{
			// t@CI_CAO̕\			
			if (openFileDialog.ShowDialog() == DialogResult.OK) {
				// [OK]ďꍇAw肳ꂽt@CJ
				openMediaFile(openFileDialog.FileName);
			}
		}

		/// <summary>
		/// Rg[c[o[̃{^ꂽɌĂ΂
		/// </summary>
		private void controlToolBar_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			// ĐpIuWFNg쐬ĂȂꍇ͂ȂɂȂ
			if (videoPlayer == null) return;
			
			// ꂽ{^ɉď؂ւ
			if (e.Button == playButton) {
				// Đ
				videoPlayer.Play();
			} else if (e.Button == pauseButton) {
				// ꎞ~
				videoPlayer.Pause();
			} else if (e.Button == stopButton) {
				// ~
				videoPlayer.Stop();
			}
		}
	}
}
